'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Created by varun on 19/12/17.
 * TODO : 1. need to take in different table configurations, 2. need a preprocessor for data before drawing table
 */

var AdharaTableView = function (_AdharaView) {
    _inherits(AdharaTableView, _AdharaView);

    function AdharaTableView() {
        _classCallCheck(this, AdharaTableView);

        return _possibleConstructorReturn(this, (AdharaTableView.__proto__ || Object.getPrototypeOf(AdharaTableView)).call(this));
    }

    /**
     * @typedef {Object} ColumnConfig
     * @property {String} key - column key
     * @property {String} name - column name that is to be rendered
     * @property {Boolean} trust_as_html - whether to render as text content or HTML content
     * @example
     * {
     *  key: "column_key",
     *  name: "Column Name",
     *  trust_as_html: false // whether to render HTML as buttons or not
     * }
     * */

    /**
     * @typedef {Object} TableConfig
     * @property {String} title - Table title
     * @property {Boolean} add_new - add new button on the table
     * @property {Boolean} nav - Add navigation component or not
     * @property {Array<ColumnConfig>} columns - list of column configuration
     * */

    /**
     * @function
     * @instance
     * @returns {TableConfig}
     * */


    _createClass(AdharaTableView, [{
        key: 'render',
        value: function render(containerSelector) {
            this.container = document.querySelector(containerSelector);
            this.container.innerHTML = Handlebars.templates[this.template]({ 'config': this.config, 'data': this.data });
            this.format(this.container);
        }
    }, {
        key: 'config',
        get: function get() {
            return {
                title: 'Adhara Table',
                add_new: false,
                nav: false,
                columns: []
            };
        }
    }, {
        key: 'template',
        get: function get() {
            return 'table';
        }
    }]);

    return AdharaTableView;
}(AdharaView);
//# sourceMappingURL=TableView.js.map