"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @class
 * @classdesc a base class that is to be extended by all the view classes
 * */
var AdharaView = function () {
    function AdharaView() {
        _classCallCheck(this, AdharaView);

        Adhara.instances[this.constructor.name] = this;
        this._data = null;
    }

    _createClass(AdharaView, [{
        key: "dataChange",
        value: function dataChange(new_data) {
            this._data = new_data;
        }
    }, {
        key: "render",
        value: function render(containerSelector) {
            this.container = document.querySelector(containerSelector);
            this.container.innerHTML = Handlebars.templates[this.template](this.data);
            this.format(this.container);
            this.renderSubViews();
        }
    }, {
        key: "getContentContainer",
        value: function getContentContainer() {
            return this.DOMcontent.querySelector(this.contentSelector);
        }

        /**
         * @typedef {Object} SubView - Sub view configuration
         * @property {String} container_selector - container's CSS selector
         * @property {class} view - view class reference of the sub view
         * */

        /**
         * @function
         * @instance
         * @returns Array<SubView>
         * */

    }, {
        key: "renderSubViews",
        value: function renderSubViews() {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.subViews[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var sub_view = _step.value;

                    var view = Adhara.getView(sub_view.view);
                    view.render(sub_view.container_selector);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }, {
        key: "format",
        value: function format() {
            //Control the DOM elements after rendering
        }
    }, {
        key: "data",
        get: function get() {
            return this._data || {};
        }
    }, {
        key: "template",
        get: function get() {
            if (AdharaRouter.getCurrentPageName()) {
                return AdharaRouter.getCurrentPageName().replace(/_/g, "-");
            } else {
                var className = this.constructor.name.toLowerCase();
                if (className.endsWith("view")) {
                    return className.slice(0, className.length - 4);
                } else {
                    return className;
                }
            }
        }
    }, {
        key: "contentSelector",
        get: function get() {
            throw new Error("Not implemented");
        }
    }, {
        key: "subViews",
        get: function get() {
            return [];
        }
    }]);

    return AdharaView;
}();
//# sourceMappingURL=View.js.map